
; PICBASIC PRO(TM) Compiler 2.50a, (c) 1998, 2007 microEngineering Labs, Inc. All Rights Reserved.  
_USED			EQU	1

	INCLUDE	"D:\PBP\18F2550.INC"


; Define statements.
#define		OSC		     48
#define		ADC_BITS		 10 		
#define		ADC_CLOCK		 6		
#define		ADC_SAMPLEUS		 50 	

RAM_START       		EQU	00000h
RAM_END         		EQU	003FFh
RAM_BANKS       		EQU	00004h
BANK0_START     		EQU	00060h
BANK0_END       		EQU	000FFh
BANK1_START     		EQU	00100h
BANK1_END       		EQU	001FFh
BANK2_START     		EQU	00200h
BANK2_END       		EQU	002FFh
BANK3_START     		EQU	00300h
BANK3_END       		EQU	003FFh
BANKA_START     		EQU	00000h
BANKA_END       		EQU	0005Fh

FLAGS           		EQU	RAM_START + 000h
R0              		EQU	RAM_START + 001h
R1              		EQU	RAM_START + 003h
R2              		EQU	RAM_START + 005h
R3              		EQU	RAM_START + 007h
R4              		EQU	RAM_START + 009h
R5              		EQU	RAM_START + 00Bh
R6              		EQU	RAM_START + 00Dh
R7              		EQU	RAM_START + 00Fh
R8              		EQU	RAM_START + 011h
T1              		EQU	RAM_START + 013h
GOP             		EQU	RAM_START + 015h
RM1             		EQU	RAM_START + 016h
RM2             		EQU	RAM_START + 017h
RR1             		EQU	RAM_START + 018h
RR2             		EQU	RAM_START + 019h
RS1             		EQU	RAM_START + 01Ah
RS2             		EQU	RAM_START + 01Bh
_x               		EQU	RAM_START + 01Ch
_y               		EQU	RAM_START + 01Eh
_buffer          		EQU	RAM_START + 020h
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTC
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISC
#define _bt1             	_PORTB??0
#define _bt2             	_PORTB??1
#define _bt3             	_PORTB??2
#define _bt4             	_PORTB??3
#define _pinTx           	_PORTC??6
#define _TRISA??0        	 TRISA, 000h
#define _TRISA??1        	 TRISA, 001h
#define _INTCON2??7      	 INTCON2, 007h
#define _PORTB??0        	 PORTB, 000h
#define _TRISB??0        	 TRISB, 000h
#define _PORTB??1        	 PORTB, 001h
#define _TRISB??1        	 TRISB, 001h
#define _PORTB??2        	 PORTB, 002h
#define _TRISB??2        	 TRISB, 002h
#define _PORTB??3        	 PORTB, 003h
#define _TRISB??3        	 TRISB, 003h
#define _PORTC??6        	 PORTC, 006h
#define _TRISC??6        	 TRISC, 006h

; EEPROM data.


	INCLUDE	"18F255~1.MAC"
	INCLUDE	"D:\PBP\PBPUSB18.LIB"

	MOVE?CT	001h, _TRISA??0
	MOVE?CT	001h, _TRISA??1
	MOVE?CB	00Dh, ADCON1
	MOVE?CB	0AEh, ADCON2
	MOVE?CT	000h, _INTCON2??7
	MOVE?CT	001h, _TRISB??0
	MOVE?CT	001h, _TRISB??1
	MOVE?CT	001h, _TRISB??2
	MOVE?CT	001h, _TRISB??3
	MOVE?CT	000h, _TRISC??6
	USBINIT?	

	LABEL?L	_main	
	ADCIN?CW	000h, _x
	ADCIN?CW	001h, _y
	SHIFTR?WCW	_x, 002h, T1
	SHIFTL?WCW	T1, 002h, _x
	SHIFTR?WCW	_y, 002h, T1
	SHIFTL?WCW	T1, 002h, _y
	MAX?WCW	_x, 00180h, T1
	MIN?WCW	T1, 0027Fh, T1
	SUB?WCW	T1, 00180h, _x
	MAX?WCW	_y, 00180h, T1
	MIN?WCW	T1, 0027Fh, T1
	SUB?WCW	T1, 00180h, _y
	MOVE?WB	_y, _buffer
	MOVE?WB	_x, _buffer + 00001h
	XOR?BCW	PORTB, 00Fh, T1
	AND?WCB	T1, 00Fh, _buffer + 00002h
	USBSERVICE?	
	USBOUT?CBCL	001h, _buffer, 003h, _main
	GOTO?L	_main

	END
